#include <stdio.h>	// for printf()
#include "Shared.h"
#include "CMMainView.h"
#include "CMPersonView.h"

// FOR R5 COMPAT:
void blend_color_func(rgb_color* target, const rgb_color other, uint8 amount)
{
	const uint8 alphaMix = (uint8)( ((int16(other.alpha)-int16(255-target->alpha))*amount)/255
									+ (255-target->alpha) );
	target->red = (uint8)( ((int16(other.red)-int16(target->red))*alphaMix)/255
								+ target->red );
	target->green = (uint8)( ((int16(other.green)-int16(target->green))*alphaMix)/255
								+ target->green );
	target->blue = (uint8)( ((int16(other.blue)-int16(target->blue))*alphaMix)/255
								+ target->blue );
	target->alpha = (uint8)( ((int16(other.alpha)-int16(target->alpha))*amount)/255
								+ target->alpha );
}
rgb_color blend_color(rgb_color c1, rgb_color c2, uint8 amt)
{
	blend_color_func(&c1, c2, amt);
	return(c1);
}


CMMainView :: CMMainView(BRect rect)
	:BView(rect, "parent", B_FOLLOW_ALL, B_WILL_DRAW | B_NAVIGABLE | B_FRAME_EVENTS)
{
	SetViewColor ( ui_color( B_PANEL_BACKGROUND_COLOR ) );

NameListArray = new const char *[100];
}

void 
CMMainView :: MessageReceived(BMessage *msg)
{
	switch(msg->what)
	{
	
		case CM_LIST_SELECTION_CHANGED:
			{
				if (lview->CurrentSelection() > -1){
				personView->ChangePerson( NameListArray[lview->CurrentSelection()] );
				}
				else
				{
					personView->ChangePerson("0");
					printf("Should be right\n");
				}
				break;
			
			}
	
	
	}//end switch

}

void CMMainView :: DoEverything(){

Window()->Lock();


	personView = new CMPersonView(BRect(110 + 20,10, Bounds().Width() - 10, Bounds().Height()-15));
	AddChild(personView);

	NameListArray[0] = "Zero";
	NameListArray[1] = "One";
	NameListArray[2] = "Two";
	NameListArray[3] = "Three";
	NameListArray[4] = "Four";
	lview = new CMListView(BRect(10,10,102,Bounds().Height()-15), NameListArray, 5);


	
	sView = new BScrollView("scroll_names",lview, B_FOLLOW_LEFT | B_FOLLOW_TOP, 0, false, true);
	AddChild(sView);
		

Window()->Unlock();
// Developer's note:
	/*
	 *		Thw DoEverything() functions are used so I can haphazardly make pointers to my classes via new
	 *		and also so that I can more quickly diagnose where a problem lies.  It is also nice to show 
	 *		something on the screen while still working behind the scenes.  This app itself is not complex,
	 *		but still, the loading of a few hundred customer files can take some time.
	 *					--The loon
	*/
	lview->DoEverything();
	personView->DoEverything();
}

void CMMainView :: FrameResized(float width, float height)
{
	sView->ResizeTo(110, Bounds().Height()-21);
}

void
CMMainView :: Draw(BRect drawRect)
{

	SetHighColor(tint_color(ViewColor(), B_LIGHTEN_2_TINT));
	rgb_color color = (rgb_color){50,200,255};
	SetLowColor( blend_color(color, HighColor(), 198) );
	FillRect(Bounds(), stripePattern);

}

