
#include "Shared.h"

#include "CMPersonView.h"
#include "CMListView.h"

CMPersonView :: CMPersonView(BRect rect)
	:BView(rect, "_CMPersonView", B_FOLLOW_ALL, B_WILL_DRAW | B_NAVIGABLE | B_FRAME_EVENTS)
{
	DoneOnce=false; IsNewCustomer = false;	fperson = "";	SetViewColor(225,225,225);	WorkingFolder="/tmp/";
	CustomerIsOpen = false;
	AreHidden = false;
	PrevSize = BPoint(rect.Width(), rect.Height());
}

void CMPersonView :: FrameResized(float width, float height)
{
	if(!IsNewCustomer && CustomerIsOpen)	{	since->MoveTo(width/2-80, 15);	}

	/* // Testing during development to due special alignments for better viewing based on window size.
		// plan is to keep Column 1 and Colunm 2 of objects evenly spaced on screen, instead of tagged
		// to one side or the other
		
	if(AreHidden){
	
	float ByX = (width - PrevSize.x) /2.0;
	
	if (width < PrevSize.x){}

	Name->MoveBy( ByX ,0);
	Company->MoveBy(ByX,0);
	
	PrevSize.x=width;
	}
	*/
	Draw(Bounds());
	
}

void CMPersonView :: DoEverything()
{ if (fperson != "" && !DoneOnce){

	DoneOnce = true;
	Window()->Lock();

	float left = 18.0;
	float top = 50;
	Window()->Unlock();

	int fRows=0;	// Tracks # of columns.  For simplicitly and readability, math regarding 
					// the 0 starting count is done later, for the second column.

// First Column
	BRect ControlRect(left, top  ,left+160, top+20);
	
	//		NAME
	ControlRect.right += 30;
	Name = new BTextControl(ControlRect, "Name", "Name: ",fperson,  0, B_FOLLOW_NONE);
	Name->SetDivider(35);	AddChild(Name);
	fRows=1;	

	
	//		COMPANY
	ControlRect.top +=30;	ControlRect.bottom +=30;	ControlRect.left -=15; ControlRect.right += 10;
	Company = new BTextControl(ControlRect, "Company", "Company: ", "", 0, B_FOLLOW_NONE);
	Company->SetDivider(50); AddChild(Company);
	fRows=2;
	
	//		Address ONE
	ControlRect.top +=30;	ControlRect.bottom +=30;
	Address1 = new BTextControl(ControlRect, "Company", "Address: ", "", 0, B_FOLLOW_NONE);
	Address1->SetDivider(50); AddChild(Address1);
	fRows=3;

	//		Address TWO
	ControlRect.top +=30;	ControlRect.bottom +=30;	ControlRect.right -= 50;
	Address2 = new BTextControl(ControlRect, "Company", "Address: ", "", 0, B_FOLLOW_NONE);
	Address2->SetDivider(50); AddChild(Address2);
	fRows=4;	
	
	

// Second Column
	ControlRect.top -= fRows*30 - 30;	ControlRect.bottom -= fRows*30 - 30;
	ControlRect.left += 215;	ControlRect.right +=160;
	
	Window()->Lock();
	float SaveLeft = ControlRect.left;
	float SaveRight = ControlRect.right;
	ControlRect.top	-= 30;		ControlRect.bottom -= 30;
	ControlRect.left = Bounds().Width()/2-80;
	ControlRect.right = ControlRect.left + 120;

	if (IsNewCustomer){
		FirstDate = new BTextControl(ControlRect, "FirstDate", "Date: ","",  0, B_FOLLOW_RIGHT);
		FirstDate->SetDivider(40);	AddChild(FirstDate);}
	else{
		float lft = Bounds().Width()/2-80;
		BString sinceString;
		sinceString << "Customer since " << "the beginning.";// << firstDateInfo ;
		since = new BStringView(BRect(lft, 15, lft + 160, 30), "since", sinceString.String(), B_FOLLOW_NONE);
		AddChild(since);

	}
		ChangePerson(fperson);

	Window()->Unlock();


	ControlRect.left = SaveLeft;
	ControlRect.right = SaveRight;
	ControlRect.top	+= 30;		ControlRect.bottom += 30;
	
	Phone = new BTextControl(ControlRect, "Phone", "Phone: ","",  0, B_FOLLOW_RIGHT);
	Phone->SetDivider(40);	AddChild(Phone);

	ControlRect.left += 10;
	ControlRect.top	+= 30;		ControlRect.bottom += 30;
	CellPhone = new BTextControl(ControlRect, "CellPhone", "Cell: ","",  0, B_FOLLOW_RIGHT);
	CellPhone->SetDivider(30);	AddChild(CellPhone);

	ControlRect.top	+= 30;		ControlRect.bottom += 30;
	Fax = new BTextControl(ControlRect, "Fax", "Fax: ","",  0, B_FOLLOW_RIGHT);
	Fax->SetDivider(30);	AddChild(Fax);

	ControlRect.top	+= 30;		ControlRect.bottom += 30;	ControlRect.left -= 50;
	Email = new BTextControl(ControlRect, "Email", "Email: ","",  0, B_FOLLOW_RIGHT);
	Email->SetDivider(30);	AddChild(Email);

}} 

void CMPersonView :: Draw(BRect drawRect)
{
pattern stripePattern = {0x55, 0xff, 0xaa, 0x00, 0x55, 0xff, 0xaa, 0x00};

	rgb_color High = HighColor();
	rgb_color Low = LowColor();
	
	
	SetHighColor(tint_color(ViewColor(), B_DARKEN_1_TINT));
	FillRect(Bounds(), stripePattern);

	SetHighColor(High);
}

void CMPersonView :: ChangePerson(const char* TextName)
{
	fperson = TextName; // Do before DoEverything(), it depends on it

if ( strcmp (fperson, "0") ){
	BString title; title << "Customer :  " << fperson;
	Window()->SetTitle(title.String());
	DoEverything();
	if (AreHidden){
		for (int i = 0; i < CountChildren(); i++)
		{
			ChildAt(i)->Show();
		}
		AreHidden = false;
	}
	Name->SetText(fperson);
	Invalidate();
}
else
{
	Window()->SetTitle("Customer Management");
	AreHidden = true;
	CustomerIsOpen = true;
	for (int i = 0; i < CountChildren(); i++)
	{
		ChildAt(i)->Hide();
	}
}
}

